﻿--[[

Name: MusicStrem Tell Channel
Revision: $Revision: 23844 $
Date: $Date: 2007-01-07 03:01:22 -0500 (Sun, 07 Jan 2007) $
Author(s): benumbed (someone@somewhere.com)
Website: http://www.wowace.com/wiki/MusicStream
Documentation: http://www.wowace.com/wiki/MusicStream
SVN: http://svn.wowace.com/root/trunk/MusicStream
Description: A module to tell someone the track you are currently playing.
Dependencies: Ace2, MusicStream

]]--

--- ========================================================= ---
--- Revision
--- ========================================================= ---

local Revision = tonumber(string.sub("$Revision: 23844 $", 12, -3))
if not Revision then
	Revision = "2.0"
end

--- ========================================================= ---
--- Add Locale
--- ========================================================= ---
local L = AceLibrary("AceLocale-2.2"):new("TellChannel")

L:RegisterTranslations("enUS", function() return {
    ["Tell Channel"] = true,
    ["Tell someone what Track you are listening to"] = true,
	
	["Guild"] = true,
    ["Tell -Guild- what you are currently playing."] = true,	

---This is where I added in the new line for simple party announces, just like the Guild announce

  ["Party"] = true,
    ["Tell -Party- what you are currently playing."] = true,

} end)

--- ========================================================= ---
--- Add Music Library
--- ========================================================= ---
local Music = AceLibrary("Music-2.0")

--- ========================================================= ---
--- Register New Module
--- ========================================================= ---

MusicStreamTellChannel = MusicStream:NewModule("TellChannel")

--- ========================================================= ---
--- On Initialize
--- ========================================================= ---

function MusicStreamTellChannel:OnInitialize()
    self.db = MusicStream:AcquireDBNamespace("TellChannel")
	
	MusicStreamTellChannel.defaultDB = {
    }
	
	MusicStream:RegisterDefaults("TellChannel", "profile", opts or MusicStreamTellChannel.defaultDB or {})
    
	local bluecolor = "|cFF0099CC"
	local lbluecolor = "|cFF77BBFF"
	
    MusicStream.Options.args.TellChannel = {
        name = L["Tell Channel"],
        desc = L["Tell someone what Track you are listening to"],
		order = 201,
        type = "group",
        args = {
			header = {
				type = "header",
				name = bluecolor..L["Tell Channel"].."  |c88888888"..Revision,
				icon = "Interface\\Addons\\MusicStream\\icon.tga",
				iconHeight = 14,
				iconWidth = 14,
				order = 1
            },
			blank = {
       			type = "header",
				order = 2,
			},
        	guild = {
            	name = string.format(L["Guild"], 1),
                desc = string.format(L["Tell -Guild- what you are currently playing."], 1),
                type = "execute",
    			func = function() MSTellWho = "Guild" self.TellChannel() end,
            },
---Added in the Party announce here as well so it would populate the selection list and where to send the output

          party = {
              name = string.format(L["Party"], 1),
                desc = string.format(L["Tell -Party- what you are currently playing."], 1),
                type = "execute",
          func = function() MSTellWho = "Party" self.TellChannel() end,
          },
        }
    }
end

--- ========================================================= ---
--- Reset DB
--- ========================================================= ---

local function copyTable(to, from)
	setmetatable(to, nil)
	for k,v in pairs(from) do
		if type(k) == "table" then
			k = copyTable({}, k)
		end
		if type(v) == "table" then
			v = copyTable({}, v)
		end
		to[k] = v
	end
	setmetatable(to, from)
	return to
end

function MusicStreamTellChannel:ResetDB()
	copyTable(self.db.profile, MusicStreamTellChannel.defaultDB)
end

--- ========================================================= ---
--- Tell Channel
--- ========================================================= ---

function MusicStreamTellChannel:TellChannel()
	SendChatMessage("(Now Playing) [Title] "..Music:CurrentTitle(), MSTellWho, this.language);
	SendChatMessage("(Now Playing) [Artist] "..Music:CurrentArtist(), MSTellWho, this.language);
	SendChatMessage("(Now Playing) [Album] "..Music:CurrentAlbum(), MSTellWho, this.language);
end